<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class SensorDeFluxoFactory {
    
    use TQuery;
    
    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getSensores(){
        $sql="SELECT NRPARAMLEITCONTPESSOAS, IDMACDEVICE, IDSENSOR
                FROM FCM_PARAMLEITCONTPESSOAS";
                
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getInicioEDateSensor($param){
        $sql="SELECT TO_CHAR(DATARESET, 'HH24:mi DD/MM/YYYY') AS DATARESET, IDMONITORAMENTO
                FROM FCM_PARAMLEITCONTPESSOAS
                WHERE IDSENSOR = '".$param."'";
                
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
        // return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function resetCount($param){
        $sql="UPDATE FCM_PARAMLEITCONTPESSOAS
                      SET DATARESET = SYSDATE,
                          NRSEQLEITURA = (SELECT MAX(NRSEQLEITURA) FROM FCM_LEITCONTPESSOAS)
                    WHERE IDSENSOR = :IDSENSOR";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }

    public function modifyStatusCount($param){
        $sql="UPDATE FCM_PARAMLEITCONTPESSOAS
                      SET IDMONITORAMENTO = :IDMONITORAMENTO
                    WHERE IDSENSOR = :IDSENSOR";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }

    public function getCount($param){
        $sql="SELECT QTPESSOASENTR
                FROM FCM_LEITCONTPESSOAS
               WHERE IDSENSOR = :IDSENSOR
                 AND DTLEITURA >= (SELECT DATARESET FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR)
                 AND NRSEQLEITURA > (SELECT NRSEQLEITURA FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR)";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function getMaxNr($param){
        $sql="SELECT MAX(NRSEQLEITURA) AS NRSEQLEITURA 
               FROM FCM_LEITCONTPESSOAS
              WHERE IDSENSOR = :IDSENSOR
                AND DTLEITURA >= (SELECT DATARESET FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR)
                AND NRSEQLEITURA > (SELECT NRSEQLEITURA FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR)";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }
    public function lastCount($param){
        $sql="SELECT QTPESSOASENTR
                FROM FCM_LEITCONTPESSOAS
               WHERE IDSENSOR = :IDSENSOR
                 AND NRSEQLEITURA = (SELECT MAX(NRSEQLEITURA)
                                       FROM FCM_LEITCONTPESSOAS
                                      WHERE IDSENSOR = :IDSENSOR
                                        AND NRSEQLEITURA = (SELECT NRSEQLEITURA FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR))";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function getCountPeople($param){
        $sql="SELECT QTPESSOAS
               FROM FCM_PARAMLEITCONTPESSOAS
              WHERE IDSENSOR = :IDSENSOR";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetchAll();
    }

    public function modifyCount($param){
        $sql="UPDATE FCM_PARAMLEITCONTPESSOAS
                      SET NRSEQLEITURA = NVL(NVL(:NRSEQLEITURA,(SELECT NRSEQLEITURA FROM FCM_PARAMLEITCONTPESSOAS WHERE IDSENSOR = :IDSENSOR)),0),
                          QTPESSOAS = :QTPESSOAS
                    WHERE IDSENSOR = :IDSENSOR";
                
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertDadosSensores($dados){
        $sql="INSERT INTO FCM_LEITCONTPESSOAS (NRSEQLEITURA, IDMACDEVICE, IDSENSOR, QTPESSOASENTR, IPSENSOR,
                        NRORG, IDATIVO, OBS, DTLEITURA)
                     VALUES (:NRSEQLEITURA, :IDMACDEVICE, :IDSENSOR, :QTPESSOASENTR, :IPSENSOR,
                     :NRORG, :IDATIVO, :OBS, SYSDATE)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($dados);
        // TO_DATE(SYSDATE, 'DD/MM/YYYY HH24:MI')
        // return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $dados);
    }
}

?>