create or replace 
PROCEDURE USR_IMP_FORNECEDOR
IS
   V_CDFORNECED VARCHAR2(20);
   V_NMRAZAOSOC VARCHAR2(40);
   V_NMFANTFORN VARCHAR2(40);
   V_DSENDERECO VARCHAR2(40);
   V_CDPAIS     VARCHAR2(4);
   V_SGESTADO   VARCHAR2(2);
   V_CDMUNCIPIO VARCHAR2(7);
   V_CDCEP      VARCHAR2(15);
   V_NMBAIRRO   VARCHAR2(30);
   V_EMAIL      VARCHAR2(40);
   V_IDFORNATIV VARCHAR2(1);
   V_CDCONTCTBL VARCHAR2(20);
   V_PAISPROT   VARCHAR2(4);
   V_ESTAPROT   VARCHAR2(2);
   V_MUNIPROT   VARCHAR2(7);
   V_CTBLPROT   VARCHAR2(20);
   V_MENSERRO   VARCHAR2(250);
   V_FORNECEDOR VARCHAR2(21);
   V_IDINTERFAC VARCHAR2(1);
   V_TPIJURFORN VARCHAR2(1);
   V_FORNOUTROS VARCHAR2(20);
   
   CURSOR C_FORNECEDOR IS
      SELECT U.CDFORNECEDOR, U.NMRAZAOSOC, U.NMFANTFORNE, U.DSENDERECO, P.CDPAIS, E.SGESTADO, 
             M.CDMUNICIPIO, U.CDCEP, U.NMBAIRRO, U.EMAIL, U.IDFORNATIV, C.CDCONTCTBL,
             U.CDPAIS CDPAIS_PROT, U.SGESTADO SGESTADO_PROT, U.CDMUNCIPIO CDMUNIC_PROT, U.CDCONTCTBL CONTCTBL_PROT,
             U.IDINTERFACE
        FROM USR_PROT_FORNECEDOR U LEFT OUTER JOIN PAIS P
                                                ON U.CDPAIS = P.CDPAIS
                                   LEFT OUTER JOIN ESTADO E
                                                ON U.CDPAIS   = E.CDPAIS
                                               AND U.SGESTADO = E.SGESTADO
                                   LEFT OUTER JOIN MUNICIPIO M
                                                ON U.CDPAIS     = M.CDPAIS
                                               AND U.SGESTADO   = M.SGESTADO
                                               AND U.CDMUNCIPIO = M.CDMUNICIBGE
                                   LEFT OUTER JOIN CONTCTBL C
                                                ON U.CDCONTCTBL = C.CDCONTCTBL
       WHERE U.DTIMPORTACAO IS NULL
         AND U.LOG_ERRO IS NULL;
BEGIN
   OPEN C_FORNECEDOR;
   LOOP
      FETCH C_FORNECEDOR INTO V_CDFORNECED, V_NMRAZAOSOC, V_NMFANTFORN, V_DSENDERECO, V_CDPAIS, V_SGESTADO,
                              V_CDMUNCIPIO, V_CDCEP, V_NMBAIRRO, V_EMAIL, V_IDFORNATIV, V_CDCONTCTBL,
                              V_PAISPROT, V_ESTAPROT, V_MUNIPROT, V_CTBLPROT, 
                              V_IDINTERFAC;
      EXIT WHEN C_FORNECEDOR%NOTFOUND;
      V_MENSERRO := NULL;
      
      IF (V_CDCONTCTBL IS NULL) THEN
         V_MENSERRO := 'Conta cont'||CHR(225)||'bil'||V_CTBLPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
      END IF;
      
      BEGIN
         SELECT MIN(CDFORNECED) AS CDFORNECEDOR
           INTO V_FORNECEDOR
           FROM FORNECEDOR
          WHERE REGEXP_LIKE (NRINSJURFORN, '(^0*0|^)'||V_CDFORNECED||'$');
         --'(^0*0|^)' -> verifica se existe um fornecedor com essa inscricao exata ou com 0(zeros) a esquerda da variavel "V_CDFORNECED"
         --'$' -> Obriga terminar com o valor de V_CDFORNECED
      EXCEPTION
         WHEN OTHERS THEN
            V_FORNECEDOR := NULL;               
      END;
      
      IF (V_CDPAIS IS NOT NULL) THEN
         IF (V_SGESTADO IS NOT NULL) THEN
            IF (V_CDMUNCIPIO IS NOT NULL) THEN
               IF (V_IDINTERFAC = '1') THEN
                  IF (V_FORNECEDOR IS NULL) THEN
                     IF (V_CDCONTCTBL IS NOT NULL) THEN
                        CASE
                           WHEN LENGTH(V_CDFORNECED)<= 5  THEN V_TPIJURFORN := 'O'; V_FORNOUTROS := LPAD(V_CDFORNECED, 5, '0');
                           WHEN LENGTH(V_CDFORNECED) = 11 THEN V_TPIJURFORN := 'F';
                           WHEN LENGTH(V_CDFORNECED) = 14 THEN V_TPIJURFORN := 'J';
                           ELSE V_TPIJURFORN := 'I';
                        END CASE;
                        
                        V_FORNECEDOR := V_TPIJURFORN||(CASE WHEN V_TPIJURFORN = 'O' THEN V_FORNOUTROS ELSE V_CDFORNECED END);
                        
                        BEGIN
                           INSERT INTO FORNECEDOR(CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN, NMFANTFORN, IDSITUCADA, CDCONTCTBL, 
                                                  IDGERAFDTENT, IDUTILZIPAF)
                           VALUES(V_FORNECEDOR, V_TPIJURFORN, V_CDFORNECED, V_NMRAZAOSOC, V_NMFANTFORN, V_IDFORNATIV, V_CDCONTCTBL,
                                  'S', 'N');
                           
                           INSERT INTO ENDEFORN(CDFORNECED, DSENDEFORN, CDPAIS, SGESTADO, CDMUNICIPIO, IDTPENDEFORN)
                           VALUES(V_FORNECEDOR, V_DSENDERECO, V_CDPAIS, V_SGESTADO, V_CDMUNCIPIO, 'P');
                           
                           UPDATE PARAMFORNE
                              SET IDOBRIMPXMLNF = 'S',
                                  IDOBRCHAVACESFO = 'S'
                            WHERE CDFORNECED = V_FORNECEDOR;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := 'No foi possvel incluir o fornecedor. Ocorreu o erro: '||SQLERRM(SQLCODE);
                        END;
                     END IF;
                  ELSE
                     V_MENSERRO := 'Fornecedor j'||CHR(225)||' cadastrado no sistema.';
                  END IF;                  
               ELSIF (V_IDINTERFAC = '2') THEN
                  IF (V_FORNECEDOR IS NOT NULL) THEN
                     BEGIN
                        DELETE FROM FORNECEDOR
                         WHERE CDFORNECED = V_FORNECEDOR;                        
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_MENSERRO := 'No foi possvel excluir o fornecedor. Ocorreu o erro: '||SQLERRM(SQLCODE);
                     END;
                  ELSE
                     V_MENSERRO := 'Fornecedor n'||CHR(227)||'o cadastrado no sistema. ';
                  END IF;
               ELSE
                  IF (V_FORNECEDOR IS NOT NULL) THEN
                     IF (V_CDCONTCTBL IS NOT NULL) THEN
                        BEGIN
                           UPDATE FORNECEDOR
                              SET NMRAZSOCFORN = V_NMRAZAOSOC,
                                  NMFANTFORN   = V_NMFANTFORN,
                                  IDSITUCADA   = V_IDFORNATIV,
                                  CDCONTCTBL   = V_CDCONTCTBL,
                                  IDGERAFDTENT = 'S', 
                                  IDUTILZIPAF  = 'N'
                            WHERE CDFORNECED = V_FORNECEDOR;
                            
                            UPDATE ENDEFORN
                               SET DSENDEFORN  = V_DSENDERECO,
                                   CDPAIS      = V_CDPAIS,
                                   SGESTADO    = V_SGESTADO,
                                   CDMUNICIPIO = V_CDMUNCIPIO,
                                   NRCEPFORN   = V_CDCEP,
                                   NMBAIRFORN  = V_NMBAIRRO,
                                   DSEMAILFORN = V_EMAIL
                             WHERE CDFORNECED  = V_FORNECEDOR
                               AND IDTPENDEFORN = 'P';
                           
                           UPDATE PARAMFORNE
                              SET IDOBRIMPXMLNF = 'S',
                                  IDOBRCHAVACESFO = 'S'
                            WHERE CDFORNECED = V_FORNECEDOR;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_MENSERRO := 'No foi possvel alterar o cadastro de fornecedor. Ocorreu o erro: '||SQLERRM(SQLCODE);
                        END;
                     END IF;
                  ELSE
                     V_MENSERRO := 'Fornecedor n'||CHR(227)||'o cadastrado no sistema. ';
                  END IF;
               END IF;
            ELSE
               V_MENSERRO := V_MENSERRO||'C'||CHR(243)||'digo do munic'||CHR(237)||'pio '||V_MUNIPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
            END IF;
         ELSE
            V_MENSERRO := V_MENSERRO||'Sigla do estado '||V_ESTAPROT||' n'||CHR(227)||'o cadastrado no sistema.';
         END IF;
      ELSE
         V_MENSERRO := V_MENSERRO||'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||V_PAISPROT||' n'||CHR(227)||'o cadastrado no sistema. ';
      END IF;
      
      /* E SE HOUVER MAIS DE UM FORNECEDOR COM O MESMO CDIGO NA TABELA INTERMEDIRIA? */
      IF (V_MENSERRO IS NOT NULL) THEN
         UPDATE USR_PROT_FORNECEDOR
            SET STATUS   = 'E',
                LOG_ERRO = V_MENSERRO
          WHERE CDFORNECEDOR = V_CDFORNECED;
      ELSE
         UPDATE USR_PROT_FORNECEDOR
            SET DTIMPORTACAO = SYSDATE,
                HRIMPORTACAO = TO_CHAR(SYSDATE, 'HH24:MI')
          WHERE CDFORNECEDOR = V_CDFORNECED;
      END IF;
   END LOOP;
   CLOSE C_FORNECEDOR;
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      V_MENSERRO := SQLERRM(SQLCODE);
      UPDATE USR_PROT_FORNECEDOR
         SET STATUS   = 'E',
             LOG_ERRO = V_MENSERRO
       WHERE CDFORNECEDOR = V_CDFORNECED;
      
      COMMIT;
      CLOSE C_FORNECEDOR;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_IMP_FORNECEDOR','5.85.XXX'); END;
/